searchNodes=[{"doc":"The Umbra.GenServer is the only module users should care.You only need to use that module to get started. Umbra.Operations is include behind the scene to adds macros and so function generators.Example:defmodule MyGenServer do use Umbra.GenServer # your code endYou can use Behaviours to override the default Umbra.GenServer behaviour :Umbra.Behaviour.Default which is used by default.Umbra.Behaviour.Strict.Umbra.Behaviour.Tolerant.To use a specific Behaviour, you can do:defmodule MyGenServer do use Umbra.GenServer, behaviour: Umbra.GenServer.Tolerant endUmbra is overridable by callbacks, but you should use it at your own depends.You can also use Extensions to modify the behaviour of your GenServer :Umbra.Extension.NameSetterUmbra.Extension.Registry","ref":"Umbra.GenServer.html","title":"Umbra.GenServer","type":"behaviour"},{"doc":"This callback is used to retrieve the PID.t from the first argument of each client-side genserver function.Without any extensions, only PID.t are working.The Umbra.Extension.Registry extension did set this callback to retrieve the PID.t from the GenServer state/struct.","ref":"Umbra.GenServer.html#c:__get_pid__/1","title":"Umbra.GenServer.__get_pid__/1","type":"callback"},{"doc":"This callback is used to do some changement on state or just initialize some stuff for extensions.It's a callback which only should be override! You should call super(state) when success at the end of your own implementation.The Umbra.Extension.Ping extension did set this callback to initialize itself.","ref":"Umbra.GenServer.html#c:__init__/1","title":"Umbra.GenServer.__init__/1","type":"callback"},{"doc":"This callback is used behind the scene by Umbra to start the GenServer and can be overrided by extensions or user when needed.It's here to allow user/extensions to modify the options passed to GenServer.It's a callback which only should be override! You should call super(linked, state, opts) at the end of your own implementation.Example:defmodule MyGenServer do use Umbra.GenServer def __start__(linked, state, opts) do {_, opts} = Keyword.pop(opts, :debug) opts = opts ++ [debug: [:trace]] super(linked, state, opts) end endThe Umbra.Extension.NameSetter extension did set a Umbra.GenServer.__start__/3 override to automatically set the process name thanks to the Umbra.Extension.NameSetter.__get_process_name__/1 callback.Basically this callback only do:GenServer.start(__MODULE__, state, opts) # or start_link if `linked` == true","ref":"Umbra.GenServer.html#c:__start__/3","title":"Umbra.GenServer.__start__/3","type":"callback"},{"doc":"This is the default behaviour of GenServer.It only does use GenServer behind the scene.","ref":"Umbra.Behaviour.Default.html","title":"Umbra.Behaviour.Default","type":"module"},{"doc":"This Behaviour does't let any possibility of mistakes.It defines :init returning {:stop, :badinit}all handlers fallback returning {:stop, {:bad_*, msg}, state}","ref":"Umbra.Behaviour.Strict.html","title":"Umbra.Behaviour.Strict","type":"module"},{"doc":"This is the most tolerant GenServer implementation.It creates fallback for all handlers returning {:noreply, state} which doesn't have any effect.GenServer.handle_call/3 returning :noreply will timeout the client, to avoid that, you can define your own handle_call implementation as follow:defcall _, client: false, state: state, do: {:reply, state, state}","ref":"Umbra.Behaviour.Tolerant.html","title":"Umbra.Behaviour.Tolerant","type":"module"},{"doc":"The extension Umbra.Extension.NameSetter is used to manage the GenServer name option.It overrides the Umbra.GenServer.__start__/3 callback to set the process name (only if missing from options) before starting the GenServer.This extension define a callback __get_process_name__/1 to retrieve/set name depending of the state when start_link/2 or start/2 of your GenServer are called.Example:defmodule MyGenServer do defstruct [:id, :other_states] use Umbra.GenServer use Umbra.Extension.NameSetter @impl Umbra.Extension.NameSetter def __get_process_name__(%__MODULE__{id: id}) do {:ok, &quot;MyGenServer::\#{id}&quot;} end # your code end","ref":"Umbra.Extension.NameSetter.html","title":"Umbra.Extension.NameSetter","type":"behaviour"},{"doc":"This callback is used to retrieve the process name depending of the parameter.It always returns {:ok, nil} except if extensions are used.The Umbra.Extension.Registry extension did set this callback to create the process name from the state thanks to a Registry (also called a via_name).You have to take care of the declaration orders.","ref":"Umbra.Extension.NameSetter.html#c:__get_process_name__/1","title":"Umbra.Extension.NameSetter.__get_process_name__/1","type":"callback"},{"doc":"The Umbra.Extension.Registry extension allow user to use a Registry under the hood and automatically use the state to retrieve the Registry via_name tuple.Warning, it directly depends of the Umbra.Extension.NameSetter extension. You have to use it before using this extension.This extension requires defining a struct for your state.You shall define your Registry under a Supervisor tree.Example:defmodule MyGenServer do defstruct [:id, :other_states] use Umbra.GenServer use Umbra.Extension.NameSetter use Umbra.Extension.Registry, registry: MyRegistry, via_key: fn %__MODULE__{id: id} -&gt; id end # your code end # Start your Registry before trying to use the GenServer {:ok, _} = Registry.start_link(keys: :unique, name: MyRegistry) # Declare the state and start the GenServer with it state = %MyGenServer{ id: 2, data: 3 } {:ok, _} = MyGenServer.start_link(state) # You can use your GenServer directly with your struct instead of the PID state |&gt; MyGenServer.do_something(state)","ref":"Umbra.Extension.Registry.html","title":"Umbra.Extension.Registry","type":"module"},{"doc":"This module generate code.It is used for client-side and server-side function generation.","ref":"Umbra.CodeGenerator.html","title":"Umbra.CodeGenerator","type":"module"},{"doc":"","ref":"Umbra.CodeGenerator.html#add_to_module/1","title":"Umbra.CodeGenerator.add_to_module/1","type":"function"},{"doc":"","ref":"Umbra.CodeGenerator.html#generate_client_function/3","title":"Umbra.CodeGenerator.generate_client_function/3","type":"function"},{"doc":"","ref":"Umbra.CodeGenerator.html#generate_function/6","title":"Umbra.CodeGenerator.generate_function/6","type":"function"},{"doc":"","ref":"Umbra.CodeGenerator.html#generate_server_function/3","title":"Umbra.CodeGenerator.generate_server_function/3","type":"function"},{"doc":"This module allows to retrieve function name and arguments from a definition.Definitions looks like this::func {:func} {:func, a} {:func, a, b} {:func, false} {:func, &quot;_&quot; &lt;&gt; rest = a} {:func, [head | tail] = a} {:func, %{id: id, name: name}} # Where :func is the name of your function.","ref":"Umbra.DefinitionExtractor.html","title":"Umbra.DefinitionExtractor","type":"module"},{"doc":"Extract the arguments used in calls from a function declaration.Example:iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_call(quote do: {:my_func}) [] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_call(quote do: {:my_func, a}) [{:a, [], UmbraTest}] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_call(quote do: {:my_func, %{} = a, b}) [{:a, [], UmbraTest}, {:b, [], UmbraTest}] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_call(quote do: {:my_func, a, &quot;toto&quot; = b}) [{:a, [], UmbraTest}, {:b, [], UmbraTest}] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_call(quote do: {:my_func, true, []}) [true, []] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_call(quote do: {:my_func, [head | tail]}) [[{:|, [], [{:head, [], UmbraTest}, {:tail, [], UmbraTest}]}]] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_call(quote do: [:lol]) ** (ArgumentError) invalid function definition","ref":"Umbra.DefinitionExtractor.html#extract_arguments_for_call/1","title":"Umbra.DefinitionExtractor.extract_arguments_for_call/1","type":"function"},{"doc":"Extract the arguments used for function declaration from a function definition.Example:iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_declaration(quote do: {:func, a}) [{:a, [], UmbraTest}] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_declaration(quote do: {:func, a, b}) [{:a, [], UmbraTest}, {:b, [], UmbraTest}] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_declaration(quote do: {:func, %Test{} = a}) [{:=, [], [{:%, [], [{:__aliases__, [alias: false], [:Test]}, {:%{}, [], []}]}, {:a, [], UmbraTest}]}] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_declaration(quote do: {:func, 42}) [42] iex&gt; Umbra.DefinitionExtractor.extract_arguments_for_declaration(quote do: {:func, true, [name: &quot;toto&quot;]}) [true, [name: &quot;toto&quot;]]","ref":"Umbra.DefinitionExtractor.html#extract_arguments_for_declaration/1","title":"Umbra.DefinitionExtractor.extract_arguments_for_declaration/1","type":"function"},{"doc":"Extract the function name from a function definition.Example:iex&gt; Umbra.DefinitionExtractor.extract_function_name(quote do: :my_func) :my_func iex&gt; Umbra.DefinitionExtractor.extract_function_name(quote do: {:toto, a}) :toto iex&gt; Umbra.DefinitionExtractor.extract_function_name(quote do: {:wow, a, b}) :wow iex&gt; Umbra.DefinitionExtractor.extract_function_name(quote do: {:my_func}) :my_func iex&gt; Umbra.DefinitionExtractor.extract_function_name(quote do: %{oops: true}) ** (ArgumentError) invalid function definition","ref":"Umbra.DefinitionExtractor.html#extract_function_name/1","title":"Umbra.DefinitionExtractor.extract_function_name/1","type":"function"},{"doc":"Extract the argument used in call from an argument declaration.Example:iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: a) {:a, [], UmbraTest} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: [] = my_array) {:my_array, [], UmbraTest} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: %{} = my_struct) {:my_struct, [], UmbraTest} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: 32 = my_number) {:my_number, [], UmbraTest} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: :test = my_atom) {:my_atom, [], UmbraTest} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: &quot;test&quot; = my_string) {:my_string, [], UmbraTest} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: nil) nil iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: 42) 42 iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: []) [] iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: [head | tail]) [{:|, [], [{:head, [], UmbraTest}, {:tail, [], UmbraTest}]}] iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: [name: &quot;toto&quot;]) [name: &quot;toto&quot;] iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: %{}) {:%{}, [], []} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: %{name: &quot;toto&quot;}) {:%{}, [], [name: &quot;toto&quot;]} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: %{&quot;name&quot; =&gt; &quot;toto&quot;}) {:%{}, [], [{&quot;name&quot;, &quot;toto&quot;}]} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: :test) :test iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: &quot;test&quot;) &quot;test&quot; iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: %Test{}) {:%, [], [{:__aliases__, [alias: false], [:Test]}, {:%{}, [], []}]} iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: toto()) ** (ArgumentError) invalid argument declaration iex&gt; Umbra.DefinitionExtractor.extract_inner_arguments_for_call(quote do: (defmodule TOTO do end)) ** (ArgumentError) invalid argument declaration","ref":"Umbra.DefinitionExtractor.html#extract_inner_arguments_for_call/1","title":"Umbra.DefinitionExtractor.extract_inner_arguments_for_call/1","type":"function"},{"doc":"Generate the client call arguments but avoid extra/useless variable.","ref":"Umbra.DefinitionExtractor.html#generate_client_call_args/1","title":"Umbra.DefinitionExtractor.generate_client_call_args/1","type":"function"},{"doc":"Generate the client definition arguments.They still quite untouched, only unused variable for the server call are automatically shadowed.","ref":"Umbra.DefinitionExtractor.html#generate_client_definition_args/1","title":"Umbra.DefinitionExtractor.generate_client_definition_args/1","type":"function"},{"doc":"Generate the GenServer parameter containing the message and the parameters.","ref":"Umbra.DefinitionExtractor.html#generate_handler_tuple/2","title":"Umbra.DefinitionExtractor.generate_handler_tuple/2","type":"function"},{"doc":"Generate the server definition arguments.They still untouched from how the user defines it.","ref":"Umbra.DefinitionExtractor.html#generate_server_definition_args/3","title":"Umbra.DefinitionExtractor.generate_server_definition_args/3","type":"function"},{"doc":"This macro help know if the given atom is an operator.Example: iex&gt; Umbra.DefinitionExtractor.is_op?(:%{}) true iex&gt; Umbra.DefinitionExtractor.is_op?(:%) true iex&gt; Umbra.DefinitionExtractor.is_op?(:toto) false","ref":"Umbra.DefinitionExtractor.html#is_op?/1","title":"Umbra.DefinitionExtractor.is_op?/1","type":"macro"},{"doc":"This macro help know if the given atom is a Elixir registered keyword.Example: iex&gt; Umbra.DefinitionExtractor.is_registered_keyword?(:def) true iex&gt; Umbra.DefinitionExtractor.is_registered_keyword?(:toto) false","ref":"Umbra.DefinitionExtractor.html#is_registered_keyword?/1","title":"Umbra.DefinitionExtractor.is_registered_keyword?/1","type":"macro"},{"doc":"This macro help know if the given atom is a valid name for functions or variables. It should be used in when guards.Example: iex&gt; Umbra.DefinitionExtractor.is_var_name?(:toto) true iex&gt; Umbra.DefinitionExtractor.is_var_name?(:tata) true iex&gt; Umbra.DefinitionExtractor.is_var_name?(:%{}) false","ref":"Umbra.DefinitionExtractor.html#is_var_name?/1","title":"Umbra.DefinitionExtractor.is_var_name?/1","type":"macro"},{"doc":"Shadow inner argument declaration used for client function declaration.Example:iex&gt; Umbra.DefinitionExtractor.shadow_arguments(quote do: 42 = a) {:=, [], [42, {:a, [], UmbraTest}]} iex&gt; Umbra.DefinitionExtractor.shadow_arguments(quote do: %{test: test} = a) {:=, [], [{:%{}, [], [test: {:_test, [], UmbraTest}]}, {:a, [], UmbraTest}]} iex&gt; Umbra.DefinitionExtractor.shadow_arguments(quote do: [head | tail] = a) {:=, [], [[{:|, &#39;&#39;, [{:_head, [], UmbraTest}, {:_tail, &#39;&#39;, UmbraTest}]}], {:a, &#39;&#39;, UmbraTest}]} iex&gt; Umbra.DefinitionExtractor.shadow_arguments(quote do: [head | tail]) [{:|, [], [{:head, [], UmbraTest}, {:tail, &#39;&#39;, UmbraTest}]}] iex&gt; Umbra.DefinitionExtractor.shadow_arguments(quote do: [head | tail]) [{:|, [], [{:head, [], UmbraTest}, {:tail, [], UmbraTest}]}]","ref":"Umbra.DefinitionExtractor.html#shadow_arguments/1","title":"Umbra.DefinitionExtractor.shadow_arguments/1","type":"function"},{"doc":"Shadow left value in argument declaration/assignment used for client function declaration.Example:iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: 42) 42 iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: %{test: test}) {:%{}, [], [test: {:_test, [], UmbraTest}]} iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: []) [] iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: [head | tail]) [{:|, &#39;&#39;, [{:_head, [], UmbraTest}, {:_tail, &#39;&#39;, UmbraTest}]}] iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: %Test{id: 42}) {:%, [], [{:__aliases__, [alias: false], [:Test]}, {:%{}, [], [id: 42]}]} iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: %Test{id: id}) {:%, [], [{:__aliases__, [alias: false], [:Test]}, {:%{}, [], [id: {:_id, [], UmbraTest}]}]} iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: [true = tata, false = toto]) [{:=, [], [true, {:_tata, [], UmbraTest}]}, {:=, [], [false, {:_toto, [], UmbraTest}]}] iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: [[true = tata, false = toto] | others]) [{:|, [], [[{:=, [], [true, {:_tata, [], UmbraTest}]}, {:=, [], [false, {:_toto, [], UmbraTest}]}], {:_others, [], UmbraTest}]}] iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: &lt;&lt;32 :: a&gt;&gt;) {:&lt;&lt;&gt;&gt;, [], [{:&quot;::&quot;, [], [32, {:_a, [], UmbraTest}]}]} iex&gt; Umbra.DefinitionExtractor.shadow_inner_arguments(quote do: %{id: _id, name: _name}) {:%{}, &#39;&#39;, [{:id, {:_id, [], UmbraTest}}, {:name, {:_name, [], UmbraTest}}]}","ref":"Umbra.DefinitionExtractor.html#shadow_inner_arguments/1","title":"Umbra.DefinitionExtractor.shadow_inner_arguments/1","type":"function"},{"doc":"This modules is the facade for the Umbra.CodeGenerator module.It defines all macros definit/2, defcall/3, defcast/3, definfo/3 and defcontinue/3.","ref":"Umbra.Operations.html","title":"Umbra.Operations","type":"module"},{"doc":"Generate the GenServer GenServer.handle_call/3 callback and a client method to call the function through GenServer.call/2.By default generates the client and server function in public.Optionsprivate: boolean(), default to falsewhen: a statementserver: boolean(), default to trueclient: boolean(), default to truestate: a statement, default to _statefrom: a statement, default to _fromExampleDefining:defcall {:compute, a, b}, do: {:reply, a + b, nil}Will generate:def get_state(pid_or_state, a, b) do {:ok, GenServer.call(pid_or_state, {:compute, a, b}) end def handle_call({:compute, a, b}, _from, _state) do {:reply, a + b, nil} end","ref":"Umbra.Operations.html#defcall/3","title":"Umbra.Operations.defcall/3","type":"macro"},{"doc":"Generate the GenServer GenServer.handle_cast/2 callback and a client method to call the function through GenServer.cast/2.By default generates the client and server function in public.Optionsprivate: boolean(), default to falsewhen: a statementserver: boolean(), default to trueclient: boolean(), default to truestate: a statement, default to _stateExampleDefining:defcast {:set_state, %{id: id, name: name} = new_state}, do: {:noreply, new_state}Will generate:def set_state(pid, %{id: _id, name: _name} = new_state) do GenServer.cast(pid, {:set_state, new_state}) end def handle_cast({:set_state, %{id: id, name: name} = new_state}, _state) do {:noreply, new_state} end","ref":"Umbra.Operations.html#defcast/3","title":"Umbra.Operations.defcast/3","type":"macro"},{"doc":"Generate the GenServer GenServer.handle_continue/2 callback.It is server-side only, so no client method will be defined.Optionswhen: a statementstate: a statement, default to _stateExampleDefining:defcontinue {:send_to_process, pid, result}, state: state do Process.send(pid, result) {:noreply, state} endWill generate:def handle_continue({:send_to_process, pid, result}, state) do Process.send(pid, result) {:noreply, state} end","ref":"Umbra.Operations.html#defcontinue/3","title":"Umbra.Operations.defcontinue/3","type":"macro"},{"doc":"Generate the GenServer GenServer.handle_info/2 callback and a client method to call the function through Process.send/3.By default only generate the server-side function. The client-side function can be useful sometimes.Optionsprivate: boolean(), default to falsewhen: a statementserver: boolean(), default to trueclient: boolean(), default to falsestate: a statement, default to _stateExampleDefining:definfo {:ping}, client: true, state: state do IO.puts(:pong) {:noreply, state} endWill generate:def ping(pid) do Process.send(pid, {:ping}) end def handle_info({:ping}, state) do IO.puts(:pong) {:noreply, state} end","ref":"Umbra.Operations.html#definfo/3","title":"Umbra.Operations.definfo/3","type":"macro"},{"doc":"Generate the GenServer GenServer.init/1 callback.It is server-side only, so no client method will be defined.Optionswhen: a statementstate: a statement, default to _stateExampleDefining:definit state: state, do: {:ok, state}Will generate:def init(state: state) do {:ok, state} end","ref":"Umbra.Operations.html#definit/2","title":"Umbra.Operations.definit/2","type":"macro"},{"doc":"Umbra Umbra is a GenServer utility helping you to easily create GenServer module. It helps to reduce boilerplate code by offering you macros and code generation.Nothing obscure or magic, the code is really readable and comprehensive.","ref":"readme.html","title":"Umbra","type":"extras"},{"doc":"Add umbra for Elixir as a dependency in your mix.exs file.def deps do [ {:umbra, &quot;~&gt; 0.1.0&quot;}, ] endAfter you are done, run this in your shell to fetch the new dependency:$ mix deps.get","ref":"readme.html#installation","title":"Umbra - Installation","type":"extras"},{"doc":"To get started, after adding the dependency to your mix project, you only have to use the Umbra.GenServer and the codes did starts to be generated.Here is a really simple exemple:defmodule BasicGenServer do use Umbra.GenServer definit do: {:ok, state} defcall {:get_state}, do: {:reply, state, state} defcast {:set_state, new_state}, do: {:noreply, new_state} defcast {:increment}, do: {:noreply, state + 1} defcast {:decrement}, do: {:noreply, state - 1} end {:ok, pid} = BasicGenServer.start_link(0) # state = 0 :ok = BasicGenServer.increment(pid) # state = 1 :ok = BasicGenServer.increment(pid) # state = 2 :ok = BasicGenServer.decrement(pid) # state = 1 :ok = BasicGenServer.set_state(pid, 42) # state = 42 {:ok, 42} = BasicGenServer.get_state(pid)To deep further, please take a look at HexDocs.","ref":"readme.html#getting-started","title":"Umbra - Getting started","type":"extras"},{"doc":"The project is tested for:Elixir versionOTP version1.7.421.31.7.422.31.8.221.31.8.222.31.9.421.31.9.422.31.10.321.31.10.322.31.10.323.0Compatibility-issues only in tests for otp &lt; 21.","ref":"readme.html#tests","title":"Umbra - Tests","type":"extras"},{"doc":"Contributions are welcome!Fork it!Create your feature branch (git checkout -b your-new-feature).Commit your change in only one commit (git commit -am &quot;Add my new feature&quot;).Push your change on your fork (git push origin your-new-feature).Create a new Pull Request.","ref":"readme.html#contributing","title":"Umbra - Contributing","type":"extras"},{"doc":"Sylvain Corsini (@scorsi)","ref":"readme.html#author","title":"Umbra - Author","type":"extras"},{"doc":"The project took inspiration from the well-known ExActor.","ref":"readme.html#credits","title":"Umbra - Credits","type":"extras"}]